/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TLSContextLister helps list TLSContexts.
type TLSContextLister interface {
	// List lists all TLSContexts in the indexer.
	List(selector labels.Selector) (ret []*v1.TLSContext, err error)
	// TLSContexts returns an object that can list and get TLSContexts.
	TLSContexts(namespace string) TLSContextNamespaceLister
	TLSContextListerExpansion
}

// tLSContextLister implements the TLSContextLister interface.
type tLSContextLister struct {
	indexer cache.Indexer
}

// NewTLSContextLister returns a new TLSContextLister.
func NewTLSContextLister(indexer cache.Indexer) TLSContextLister {
	return &tLSContextLister{indexer: indexer}
}

// List lists all TLSContexts in the indexer.
func (s *tLSContextLister) List(selector labels.Selector) (ret []*v1.TLSContext, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.TLSContext))
	})
	return ret, err
}

// TLSContexts returns an object that can list and get TLSContexts.
func (s *tLSContextLister) TLSContexts(namespace string) TLSContextNamespaceLister {
	return tLSContextNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// TLSContextNamespaceLister helps list and get TLSContexts.
type TLSContextNamespaceLister interface {
	// List lists all TLSContexts in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.TLSContext, err error)
	// Get retrieves the TLSContext from the indexer for a given namespace and name.
	Get(name string) (*v1.TLSContext, error)
	TLSContextNamespaceListerExpansion
}

// tLSContextNamespaceLister implements the TLSContextNamespaceLister
// interface.
type tLSContextNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all TLSContexts in the indexer for a given namespace.
func (s tLSContextNamespaceLister) List(selector labels.Selector) (ret []*v1.TLSContext, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.TLSContext))
	})
	return ret, err
}

// Get retrieves the TLSContext from the indexer for a given namespace and name.
func (s tLSContextNamespaceLister) Get(name string) (*v1.TLSContext, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("tlscontext"), name)
	}
	return obj.(*v1.TLSContext), nil
}
